# remirepo/Fedora spec file for php-zendframework-zend-filter
#
# Copyright (c) 2015-2019 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    d78f2cdde1c31975e18b2a0753381ed7b61118ef
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-filter
%global php_home     %{_datadir}/php
%global library      Filter
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif
%global php_version  %(php -r 'echo PHP_VERSION;')

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.9.2
Release:        1%{?dist}
Summary:        Zend Framework %{library} component

License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
# 7.0 because of psr/http-factory
BuildRequires:  php(language) >= 7.0
BuildRequires:  php-date
BuildRequires:  php-iconv
BuildRequires:  php-mbstring
BuildRequires:  php-mcrypt
BuildRequires:  php-pcre
BuildRequires:  php-spl
BuildRequires:  php-zip
BuildRequires: (php-autoloader(%{gh_owner}/zend-stdlib)         >= 3.1.0 with php-autoloader(%{gh_owner}/zend-stdlib)         <  4)
# From composer, "require-dev": {
#        "pear/archive_tar": "^1.4.3",
#        "phpunit/phpunit": "^5.7.23 || ^6.4.3",
#        "psr/http-factory": "^1.0",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "zendframework/zend-crypt": "^3.2.1",
#        "zendframework/zend-servicemanager": "^2.7.8 || ^3.3",
#        "zendframework/zend-uri": "^2.6"
BuildRequires:  php-autoloader(pear/archive_tar)                >= 1.4.3
%global phpunit %{_bindir}/phpunit6
BuildRequires:  phpunit6 >= 6.4.3
%endif
BuildRequires: (php-composer(psr/http-factory)                  >= 1.0   with php-composer(psr/http-factory)                  < 2)
BuildRequires: (php-autoloader(%{gh_owner}/zend-crypt)          >= 3.2.1 with php-autoloader(%{gh_owner}/zend-crypt)          < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-servicemanager) >= 2.7.8 with php-autoloader(%{gh_owner}/zend-servicemanager) < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-uri)            >= 2.6   with php-autoloader(%{gh_owner}/zend-uri)            < 3)
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-stdlib": "^2.7.7 || ^3.1"
Requires:       php(language) >= 5.6
Requires:      (php-autoloader(%{gh_owner}/zend-stdlib)         >= 3.1.0 with php-autoloader(%{gh_owner}/zend-stdlib)         <  4)
%if ! %{bootstrap}
# From composer, "suggest": {
#        "psr/http-factory-implementation": "psr/http-factory-implementation, for creating file upload instances when consuming PSR-7 in file upload filters",
#        "zendframework/zend-crypt": "Zend\\Crypt component",
#        "zendframework/zend-i18n": "Zend\\I18n component",
#        "zendframework/zend-servicemanager": "Zend\\ServiceManager component",
#        "zendframework/zend-uri": "Zend\\Uri component for UriNormalize filter"
Suggests:       php-composer(psr/http-factory-implementation)
Suggests:       php-autoloader(%{gh_owner}/zend-crypt)
Suggests:       php-autoloader(%{gh_owner}/zend-i18n)
Suggests:       php-autoloader(%{gh_owner}/zend-servicemanager)
Suggests:       php-autoloader(%{gh_owner}/zend-uri)
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 2.8.0
Requires:       php-date
Requires:       php-iconv
Requires:       php-mbstring
Requires:       php-openssl
Requires:       php-pcre
Requires:       php-spl
# optional compression extensions
Requires:       php-bz2
Requires:       php-zlib
Suggests:       php-lzf
Recommends:     php-zip

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
The Zend\Filter component provides a set of commonly needed data filters.
It also provides a simple filter chaining mechanism by which multiple
filters may be applied to a single datum in a user-defined order.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Stdlib/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Psr/Http/Message/http-factory-autoload.php',
    '%{php_home}/Zend/Crypt/autoload.php',
    '%{php_home}/Zend/I18n/autoload.php',
    '%{php_home}/Zend/ServiceManager/autoload.php',
    '%{php_home}/Zend/Uri/autoload.php',
    '%{_datadir}/pear/Archive/Tar/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

# Need investigation
rm test/Compress/SnappyTest.php

ret=0
for cmd in "php %{phpunit}" php71 php72 php73 php74; do
  if which $cmd; then
    set $cmd
    $1 ${2:-%{_bindir}/phpunit6} || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}


%changelog
* Tue Aug 20 2019 Remi Collet <remi@remirepo.net> - 2.9.2-1
- update to 2.9.2

* Fri Jul 26 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.9.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Wed Feb 13 2019 Remi Collet <remi@remirepo.net> - 2.9.1-1
- update to 2.9.1
- add optional dependency on psr/http-factory-implementation
- use range dependencies

* Sat Feb 02 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.8.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.8.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Thu Apr 12 2018 Remi Collet <remi@remirepo.net> - 2.8.0-1
- update to 2.8.0
- raise dependency on PHP 5.6
- raise dependency on zend-stdlib 3.1.0
- always use phpunit6
- compression extensions are optional

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.7.2-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Tue Dec 19 2017 Remi Collet <remi@remirepo.net> - 2.7.2-4
- use Archive_Tar autoloader

* Thu Dec  7 2017 Remi Collet <remi@remirepo.net> - 2.7.2-3
- switch from zend-loader to fedora/autoloader

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.7.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Mon May 22 2017 Remi Collet <remi@remirepo.net> - 2.7.2-1
- Update to 2.7.2
- use phpunit6 on F26+

* Wed Feb 22 2017 Remi Collet <remi@fedoraproject.org> - 2.7.1-3
- don't convertErrorsToExceptions, fix FTBFS #1424085

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.7.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Fri Nov 25 2016 Remi Collet <remi@fedoraproject.org> - 2.7.1-2
- fix FTBFS, disable E_DEPRECATED during test suite

* Tue Apr 19 2016 Remi Collet <remi@fedoraproject.org> - 2.7.1-1
- update to 2.7.1

* Wed Apr  6 2016 Remi Collet <remi@fedoraproject.org> - 2.7.0-1
- update to 2.7.0

* Fri Feb 12 2016 Remi Collet <remi@fedoraproject.org> - 2.6.1-1
- update to 2.6.1

* Fri Feb  5 2016 Remi Collet <remi@fedoraproject.org> - 2.6.0-1
- update to 2.6.0
- raise dependency on PHP >= 5.5
- raise dependency on zend-stdlib >= 2.7

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 2.5.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Oct  1 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- normal build

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-0
- initial package, bootstrap build
